
#import "MyController.h"

@implementation MyController

-(void)awakeFromNib
{
    songs = [[NSMutableArray alloc] init];
    NSString *filePath, *base = [NSHomeDirectory() stringByAppendingFormat:@"/Library/mosievius/songlist"];
    NSMutableArray *temp = [[NSMutableArray alloc] initWithContentsOfFile:base];
    mixer = new Mixer(songs);
    mixer->startAudio();
    Sieve *s;

    int i;
    if(temp != nil) for(i = 0; i < [temp count]; i++)
    {
        filePath=[temp objectAtIndex:i];
        s = [[Sieve alloc] initWithWindowNibName:@"Sieve"];
        [s initialize:filePath table:songTable mixer:mixer];
        [songs insertObject:s atIndex:i];
        [NSThread detachNewThreadSelector:@selector(extraction:) toTarget:s withObject:songTable];
    }
    [songTable setDoubleAction:@selector(showWindow:)];
    [songTable registerForDraggedTypes:[NSArray arrayWithObjects:NSFilenamesPboardType,nil]];
    [songTable reloadData];

    [[NSNotificationCenter defaultCenter] addObserver:self selector: @selector(cleanup:) name: NSApplicationWillTerminateNotification object:NSApp];
}

-(void)cleanup:(id)i
{
    NSString *base = NSHomeDirectory();
    base = [base stringByAppendingFormat:@"/Library/mosievius/songlist"];
    NSMutableArray *temp;
    temp = [[NSMutableArray alloc] init];
    int j;
    for(j = 0; j < [songs count]; j++) [temp insertObject:[[songs objectAtIndex: j] getPath] atIndex: j];
    [temp writeToFile:base atomically:YES];
}

// Mandatory tableview data source method
- (int)numberOfRowsInTableView:(NSTableView *)tableView
{
    return [songs count];
}

- (id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn row:(int)row
{
    if([[tableColumn identifier] isEqualToString: @"0"]) return [[songs objectAtIndex:row] getName];
    else return [[songs objectAtIndex:row] getState];
}

- (Sieve *)songSelected
{
	return [songs objectAtIndex:[songTable selectedRow]];
}

- (BOOL)tableView:(NSTableView *)tableView shouldEditTableColumn:(NSTableColumn *)tableColumn row:(int)row
{
	return NO;
}

- (NSDragOperation)tableView:(NSTableView*)tv validateDrop:(id <NSDraggingInfo>)info proposedRow:(int)row proposedDropOperation:(NSTableViewDropOperation)op
{
    [tv setDropRow:[tv numberOfRows] dropOperation:NSTableViewDropAbove];
    return NSTableViewDropAbove;
}

- (BOOL)tableView:(NSTableView*)tv acceptDrop:(id <NSDraggingInfo>)info row:(int)row dropOperation:(NSTableViewDropOperation)op
{
    NSPasteboard *myPasteboard = [info draggingPasteboard];
    NSArray  *filesList, *typeArray=[NSArray arrayWithObjects:NSFilenamesPboardType,nil];
    NSString *filePath, *availableType;
    Sieve *s;
    int i;

    availableType=[myPasteboard availableTypeFromArray:typeArray];
    filesList=[myPasteboard propertyListForType:availableType];
    for (i=0;i<[filesList count];i++)
    {
        filePath=[filesList objectAtIndex:i];
        s = [[Sieve alloc] initWithWindowNibName:@"Sieve"];
        [s initialize:filePath table:songTable mixer:mixer];
        [songs insertObject:s atIndex:row+i];
        [NSThread detachNewThreadSelector:@selector(extraction:) toTarget:s withObject:songTable];
    }
    [songTable reloadData];
    [songTable selectRow:row+i-1 byExtendingSelection:NO];
    return YES;
}



@end

