/*
 *  Sieve_back.cpp
 *  mosievius
 *
 *  Created by Ari Lazier on Sun Mar 30 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#include "Sieve_back.h"

#define NORMAL 0
#define REPLACE 1

#define PRESENT 0
#define PAST 1

#define ERROR			0
#define ENERGY		1
#define CENTROID	2
#define FLUX			3
#define SPEED			4
#define PITCH			5
#define HOP				6
#define MEM				7

#define BUFFERS 16
#define WIDTH	16
#define PASS (toggle[0]^((*feats)(location, 0)>control(0))) && (toggle[1]^((*feats)(location, 1)>control(1))) && (toggle[2]^((*feats)(location, 2)>control(2))) && (toggle[3]^((*feats)(location, 3)>control(3)))
#define TFACTOR (control(SPEED)*control(PITCH))


Sieve_back::Sieve_back()
{
}


Sieve_back::~Sieve_back()
{
}


void
Sieve_back::tick(float *buffer, int size, float gain)
{
	int i, startlocation = location;
	while(callTime < hopSize)
	{
		if(PASS)
		{
			if(mode == PAST)
			{
				if(totalsegs > control(MEM)) totalsegs = control(MEM);
				curseg = (firstseg+totalsegs)%128;
				if(totalsegs < control(MEM)) totalsegs++;
				else firstseg = firstseg++;
				firstseg = firstseg%128;
				first[curseg] = location;
			}
			last[curseg] = location;
			mode = PRESENT;
			sample->get(inwin, location);
		}
		else if(control(MEM))
		{
			if(mode == PRESENT && toggle[MEM]) curseg = totalsegs*1000;
			else if(mode == PRESENT) curseg = -1;
			if(mode == PRESENT || curwin > totaltemp)
			{
				if(toggle[MEM]) curseg--;
				else curseg++;
				curwin = 0;
				ind = (firstseg+curseg%totalsegs)%128;
				totaltemp = last[ind] - first[ind];
				if(totaltemp < 0) totaltemp += rows;
			}
			mode = PAST; 
			sample->get(inwin, (first[ind]+curwin)%rows);
			curwin++;
		}
		if(PASS || control(MEM))
		{
			for(i = hopSize; i < hopSize*BUFFERS; i++) win(i-hopSize) = win(i);
			for(i = 0; i < hopSize; i++)
			{
				win(i+(BUFFERS-1)*hopSize) = inwin(i) * i / (float)hopSize + overlap(i);
				overlap(i) = inwin(i+hopSize) * (hopSize-i) / (float)hopSize;
			}
			int hop=control(HOP), h2=hop*2, h3 = hop*3;
			for(pitchTime = 0; inTime < hopSize; inTime += (float)hop/TFACTOR)
			{
				intTime = inTime;
				for(i = 0; i < hop; i++, pitchTime++) pitchwin(pitchTime) = pitchover(i) + i*win(intTime+i)/h2;
				for(; i < h2; i++) pitchover(i-hop) = pitchover(i) + .5*win(intTime+i);
				for(; i < h3; i++) pitchover(i-hop) = win(intTime+i)*(h3-i-1)/h2;
			}
			inTime -= hopSize;
			pitchwin(pitchTime) = pitchover(0);
			while((int)outTime < pitchTime)
			{
				diff = outTime-(int)outTime;
				dat = pitchwin((int)outTime)*(1-diff)+pitchwin((int)outTime+1)*diff;
				//i = floor(outTime+WIDTH);
				//if (control(PITCH) < 1.0)
					//for(dat = 0, j = floor(outTime)+1; j < i; j++)
						//dat += outwin(j) * sinc(outTime-j+WIDTH/2);
				// else for(dat = 0, j = floor(outTime)+1; j < i; j++)
				//	dat += outwin(j) * sinc((outTime-j+WIDTH/2)/control(PITCH)) / control(PITCH);
				outwin(callTime++) = dat;
				outTime += control(PITCH);
			}
			outTime -= pitchTime; 
		}
		location++;
		if(location >= rows) location = 0;
		if(location == startlocation) return;
  }
	for(i = 0; i < size; i++)
	{
		buffer[i*2] += outwin(i)*gain;
		buffer[i*2+1] += outwin(i)*gain;
	}
	while(i < callTime) outwin(i-hopSize) = outwin(i++);
	callTime -= hopSize;
}




void sort(float *a, int *b, int l, int r)
{
  static float m;
  static int j;
  int i;

  if(r > l) {
    m = a[b[r]]; i = l-1; j = r;
    for(;;) {
      while(a[b[++i]] < m) if(i >= j) break;
      while(a[b[--j]] > m) if(i >= j) break;
      if(i >= j) break;
      std::swap(b[i], b[j]);
    }
    std::swap(b[i], b[r]);
    sort(a, b, l, i-1);
    sort(a, b, i+1, r);
  }
}




void
Sieve_back::extract(NSString *file, int wSize)
{
	winSize = wSize;
	hopSize = wSize/2;
	NSString *base = NSHomeDirectory();
	base = [base stringByAppendingFormat:@"/Library/mosievius"];
	BOOL isDir;
	NSFileManager *manager = [NSFileManager defaultManager];
	[manager fileExistsAtPath:base isDirectory:&isDir];
	if(!isDir) [manager createDirectoryAtPath:base attributes:nil];
	
	
	base = [base stringByAppendingFormat:@"/"];
	base = [base stringByAppendingFormat:[[file stringByDeletingPathExtension] lastPathComponent]];
  struct stat stbuf;	
	Util util;
	sample = util.sfopen([file cString], MRS_SF_READ);
	sample->initWindow(winSize, hopSize, 0, 0);
	MSignal *src = (MSignal *)sample;
	
	feats = new FeatMatrix();
	string fstring = [[base stringByAppendingFormat: @"SFFT.mff"] cString];
  string lstring = [[base stringByAppendingFormat: @"SFFT.mdf"] cString];
  string dstring = [[base stringByAppendingFormat: @"SFFT.mlf"] cString];
	if(stat(fstring.c_str(), &stbuf)||stat(dstring.c_str(), &stbuf)||stat(lstring.c_str(), &stbuf))
	{
		Spectral1* spec = new Spectral1(src->winSize(), src->zeroSize()); 
		Extractor* extr = new FeatExtractor(src, spec); 
    feats = new FeatMatrix(src->iterations(), spec->outSize());
    extr->extract(*feats);
    feats->setName([[base stringByAppendingFormat: @"SFFT"] cString]);
		feats->write([[base stringByAppendingFormat: @"SFFT"] cString]);
		delete spec;
		delete extr;
	}
	else feats->read([[base stringByAppendingFormat: @"SFFT"] cString]);
	NSLog([base stringByAppendingFormat: @"SFFT"]);

	
	FeatMatrix *pitch = new FeatMatrix();
  fstring = [[base stringByAppendingFormat: @"Pitch.mff"] cString];
  lstring = [[base stringByAppendingFormat: @"Pitch.mdf"] cString];
  dstring = [[base stringByAppendingFormat: @"Pitch.mlf"] cString];
	if(stat(fstring.c_str(), &stbuf)||stat(dstring.c_str(), &stbuf)||stat(lstring.c_str(), &stbuf))
	{
		Pitch* spec = new Pitch(src->winSize()); 
		Extractor* extr = new FeatExtractor(src, spec); 
    pitch = new FeatMatrix(src->iterations(), spec->outSize());
    extr->extract(*pitch);
    pitch->setName([[base stringByAppendingFormat: @"Pitch"] cString]);
		pitch->write([[base stringByAppendingFormat: @"Pitch"] cString]);
		delete spec;
		delete extr;
	}
	else pitch->read([[base stringByAppendingFormat: @"Pitch"] cString]);
	NSLog([base stringByAppendingFormat: @"Pitch"]);

  rows = feats->rows();
	fvec collectVec(rows);
	collectVec = pitch->col(1);
	feats->col(0, collectVec);
	delete pitch;
	delete sample;

	max.create(8);
	min.create(8);
	control.create(8);
	overlap.create(winSize);
	inwin.create(winSize);
	win.create(BUFFERS*hopSize);
	pitchwin.create(BUFFERS*winSize);
	outwin.create(BUFFERS*winSize*10);
	pitchover.create(BUFFERS*winSize);
	dist.create(8, 128);
	sendwin.create(hopSize);
	
	float space;
	int i, j, k, sorted[rows];
  for(i = 0; i < 4; i++)
	{
		for(j = 0; j < rows; j++) sorted[j] = j;
		collectVec = feats->col(i);
		sort(collectVec.getData(), sorted, 0, rows-1);
		min(i) = collectVec(sorted[0]);
		max(i) = collectVec(sorted[rows-1]);
	}
	max(HOP) = floor((BUFFERS-1)*hopSize/3.0);
	min(HOP) = 10;
	min(PITCH) = min(SPEED) = .1;
	min(MEM) = 0;
	max(SPEED) = max(PITCH) = 2;
	max(MEM) = 127;
	for(i = 0; i < 8; i++) toggle[i] = false;
	
	control(ERROR) = control(ENERGY) = control(CENTROID) = control(FLUX) = control(MEM) = 0;
	control(SPEED) = control(PITCH) = 1;
	control(HOP) = hopSize;

	location = totalsegs = curseg = firstseg = outTime = pitchTime = inTime = callTime = 0;
	mode = PRESENT;

	
	sample = (AuFileIO*)util.sfopen([file cString], MRS_SF_READ);
	sample->initWindow(winSize, hopSize, 0, 0);

	return;
}