/* Generic client. 
   Used for testing. Later it will evolve to MARSYAS talk.
   */


#include "Client.h"
#define VERBOSE


Client::Client()
{
}



Client::~Client()
{
}



/* Write a specified number of characters to the socket. */
int
Client::write_data(int socket, char *buf, int size)
{
  int bcount;				// counts bytes read
  int br;				// bytes read this pass
  
  bcount = 0;
  br = 0;
  
  while(bcount < size) 		// Loop until full buffer
    {	
      if ((br = write(socket, buf, size-bcount)) > 0) 
	{
	  bcount += br;			// increment byte counter
	  buf += br;			// move buffer ptr for next read 
	}
      if (br < 0)
	return -1;			// signal an error to the caller
    }
  return bcount;
}

/* Call a socket */

int 
Client::call_socket(char *hostname, int portnum)
{
  struct sockaddr_in sa;
  struct hostent *hp;
  int s;
  

  if ((hp = gethostbyname(hostname)) == NULL) // do we know the host's 
    {
      return(-1);			// no
    }
  
     
  //bzero((char *)&sa, sizeof(sa));
  memset((void *)&sa, '\0', sizeof(sa));
  // bcopy(hp->h_addr, (char *)&sa.sin_addr, hp->h_length); // set address
  memcpy((void *)hp->h_addr, (void *)&sa.sin_addr, hp->h_length);
  sa.sin_family = hp->h_addrtype;
  sa.sin_port   = htons((u_short)portnum);
  

  if ((s = socket(hp->h_addrtype, SOCK_STREAM, 0)) < 0) // get socket 
    return -1;
  if (connect(s, (struct sockaddr *)&sa, sizeof(sa)) < 0)
    return (-1);
  return (s);
}


void
Client::send_message(string message)
{
  send(socket_id_, message.c_str(), message.length(),0);
  cerr << "Client Sending message = " << message << endl;
}

void
Client::receive_message(char *message)
{
  char *mes = message;
  int bytes_read;
  bytes_read = recv(socket_id_, mes, MAX_MESSAGE,0);
  cerr << "Client: Received " << bytes_read << "bytes\n";
  
}




void
Client::start(char *hostname, int portnum)
{
  
  fprintf(stderr, "Server host = %s\n", hostname);
  fprintf(stderr, "Server port = %d\n", portnum);
  socket_id_ = call_socket(hostname, portnum);
}

	
