/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* Client:
   Basic Client class for MARSYAS. 
Its based on command line. Outputs a prompt 
gets the user command and sends it to the server. 
   */



#if !defined(__Client_h)
#define __Client_h



#include <stdio.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>

#ifndef WIN32
#include <unistd.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <netdb.h>

#else
#include <io.h>
#include <winsock.h>
#endif

#include <errno.h>
#include "Communicator.h"

#include <iostream.h> 
using namespace std;


class Client : public Communicator
{
private:
  int write_data(int socket, char *buf, int size);
  int call_socket(char *hostname, int portnum);
  int socket_id_;
public:
  Client();
  ~Client();
  void start(char *hostname, int port_num);
  void send_message(string message);
  void receive_message(char *message);
};




#endif


	

	
