/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


/** 
    \class DB
    \brief Convert to DBs

    Convert values of input fvec to DBs. (20log10()).
*/



#if !defined(__DB_h)
#define __DB_h
	

#include "System.h"
#include <math.h> 

class DB: public System
{
private:
  float floor_;
public:
  DB();
  DB(unsigned int inSize, float floor);
  void process(fvec& in, fvec& out);
  
};


#endif
	
	
