/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


/**
   \class  FvecExtractor
   \brief  Extractor that produces a fvec

   Abstract base class for extractors that are initialized with a
MSignal and calculate a fvec.
*/




#if !defined(__FvecExtractor_h)
#define __FvecExtractor_h



#include "MSignal.h"
#include <string.h>

class FvecExtractor
{
protected:
  string type_;
  fvec in_;
  unsigned int lineSize_;
  MSignal *src_;
  
public:
  FvecExtractor(MSignal* in, unsigned int lineSize);
  virtual ~FvecExtractor();
  virtual void extract(unsigned int start, unsigned int end, fvec& vec) =0;
};


#endif	


	
