/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/** 
    \class PeakPicker
    \brief Pick Peaks 

   Simple Peak Picking System 
*/

#if !defined(__PeakPicker_h)
#define __PeakPicker_h

#include "System.h"	
#include "ivec.h"
#include "pitchfind.h"
#include "Memory.h"

class PeakPicker: public System
{
private: 
  fvec temp_;
  fvec temp2_;
  fvec histo_;
  unsigned int factor_;
  unsigned int start_;
  unsigned int stop_;
  int bw_;
  unsigned int numPeaks_;
  unsigned int freq2bin_;
  unsigned int octave_choice_;
public:
  PeakPicker();
  //  ~PeakPicker();
  PeakPicker(unsigned int inSize, unsigned int factor,unsigned int numPeaks, unsigned int start, unsigned int stop, int bw);
  void process(fvec& in, fvec& out);
};

#endif
