
#if !defined(__Pitch_h)
#define __Pitch_h

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include "System.h"
#include "MSignal.h"
#include "fmatrix.h"	
#include "MagFFT.h"
#include "Hamming.h"
#include "DB.h"
#include "defs.h"
#include "math.h"
#include "SpectralPeak.h"

class Pitch: public System
{	
  SpectralPeak *spectralPeaks_;
	fvec peaks_;
	fvec amps_;
	fvec partials_;
	fvec phases_;
	fvec error_;
	fvec candidates_;
	fvec spectrum_;
	
	int nBins_;
	int resolution_;
	float getError(float bin, float maxAmp, int nPeaks);
	int getClosest(float bin, int peakIndex, int nPeaks);
  int round(float r);
  void init();

public:
  Pitch(int inSize);
  ~Pitch();
  void process(fvec& in, fvec& out);
	fvec& getPeaks();
	fvec& getSpectrum();
	fvec& getAmps();
	fvec& getPhases();
	int numberOfPartials();
};

#endif
