
#if !defined(__Pitch_h)
#define __Pitch_h

#include <stdio.h>
#include <stdlib.h>
#include "System.h"	
#include "MagFFT.h"
#include "Hamming.h"
#include "math.h"
#include "PitchModel.h"
#include "DFCC.h"

class Pitch: public System
{
  PitchModel *model_;
	DFCC *envelope_;
  fvec spectrum_;
  fvec quality_;
  fvec partials_;
	fvec freqs_;
	fvec amps_;
  fvec likelihood_;
	fvec hist_;
	fmatrix thist_;
	fvec ccfs_;
	fvec pars_;
	fvec probs_;
	fvec indexes_;
	fvec parnum_;
	fvec fft_;
	fvec highest_;
	fvec markovbins_;
	fvec markovprobs_;
	
	int finalists_;
  int npartials_;
  int maxpartials_;
  int minBin_;
	int maxBin_;
	int order_;
	bool train_;
	
  int match(int candidate);
  int round(float r);
	float inst(int pitch);
	float interpolate(int pitch, fvec& vals);

public:
  Pitch(string model);
  ~Pitch();
  Pitch(string model, int inSize);
  void init();
  void process(fvec& in, fvec& out);
  void train();

};

#endif
