
#if !defined(__PitchModel_h)
#define __PitchModel_h

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include "System.h"
#include "MSignal.h"
#include "fmatrix.h"	
#include "MagFFT.h"
#include "Hamming.h"
#include "SoundFileIO.h"
#include "defs.h"
#include "math.h"
#include "Collection.h"
#include "Util.h"
#include "DFCC.h"

class PitchModel
{
  MagFFT *magfft_;
  Hamming *hamming_;
  vector<string> featNames_;
  fvec windowed_;
  fvec spectrum_;
	fvec hams_;
  fvec quality_;
  fvec partials_;
  fvec in_;
	fmatrix probs_;
	fmatrix means_;
	fmatrix vars_;
	fmatrix norms_;
  fmatrix stats_;
  string name_;
  string filename_;
  ofstream mos;
  int maxpartials_;
  int inSize_;
	int hamweights_;

  int round(float r);
  void createStandard(void);

public:
  PitchModel(int inSize);
  PitchModel(string model, int inSize);
  ~PitchModel();
  void init();
  fvec hamfft_;
	void updateModel();
	void readModel();
	void writeModel();
  void add(fvec& in, int label);
	void add(fvec& pars, fvec& indexes, int label);
  void addSource(MSignal *src, int label);
	int getPartials(fvec& in, fvec& spectrum, fvec& fft, fvec& quality, fvec& partials);
  int getModel(int candidate);
	float normpdf(float value, float std, float mean);
	float fdist(int model, int partial, float value);
	float prob(int model, int partial);
};

#endif
