/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/**
   \class  RandShuffler
   \brief  Interface for shufflers

   Abstract base class used as interface for shufflers. RandShufflers 
   as input a FeatMatrix and produce a temporal reording (shuffling) 
   of the file and returns it as a ivec called mapping.
*/


/* RandShuffler:

*/


#if !defined(__RandShuffler_h) 
#define __RandShuffler_h

#include <string.h>
#include "FeatMatrix.h"
#include "fvec.h"
#include "Shuffler.h"

class RandShuffler: public Shuffler
{
protected:
  string type_;
  
public:
  RandShuffler();
  ~RandShuffler();
  void shuffle(FeatMatrix& fmatrix, ivec &mapping);
};



#endif

   
