/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


/**
   \class Sine
   \brief Sine wave Instrument
   
   Instrument for generating single Sine waves of 
a particular frequency, amplitude and duration. 
*/


#if !defined(__Sine_h)
#define __Sine_h

#include "Instrument.h"
#include <math.h>

class Sine: public Instrument
{
private:
  float freq_;
  float amp_;
  float duration_;
  unsigned long wavetableSize_;
  fvec wavetable_;
  
public:
  Sine(unsigned int srate);
  void init(float freq, float amp, float duration);
  void init_note(short note_num, float amp, float duration);
  void get(fvec &win, unsigned long index);
  void put(fvec &win, unsigned long index);
  unsigned long iterations();
};


#endif

