
#if !defined(__SpectralPeak_h)
#define __SpectralPeak_h

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include "System.h"
#include "MSignal.h"
#include "fmatrix.h"	
#include "MagFFT.h"
#include "Hamming.h"
#include "DB.h"
#include "defs.h"
#include "math.h"

class SpectralPeak: public System
{	
  MagFFT *magfft_;
  Hamming *hamming_;
	DB *db_;
	
  fvec windowed_;
  fvec spectrum_;
	fvec dbspectrum_;
	fvec amps_;
	fvec phases_;
	fvec partials_;
	fvec width_;
	fvec fft_;
	
  int nBins_;
	int nPartials_;
	float threshhold_;
	
  int round(float r);
  void init();

public:
  SpectralPeak(int maxPeaks);
  SpectralPeak(int inSize, int maxPeaks);
  SpectralPeak(int inSize, int maxPeaks, float threshhold);
  ~SpectralPeak();
  void process(fvec& in, fvec& out);
	fvec& getAmps();
	fvec& getPhases();
	fvec& getSpectrum();
	int numberOfPartials();
};

#endif
