/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/**
   \class WavFileIO
   \brief SoundFileIO for .wav soundfiles
   
   SoundFileIO reader/writer for .wav sound files.
   (Next, Sun audio format). 
*/



/* WavFileIO:
   Soundfile reader/writer for .wav
*/


#if !defined(__WavFileIO_h)
#define __WavFileIO_h




#include <string.h>
#include "MSignal.h"
#include <stdio.h>
#include "defs.h"
#include "SoundFileIO.h"


class WavFileIO: public SoundFileIO
{
private:
  long pos_;
  long written_;
  unsigned short bits_;
  
public:
  WavFileIO(string filename, int mode);
  ~WavFileIO();
  void init();
  int check_type();
  void get(fvec &win, unsigned long index);
  void put(fvec &win, unsigned long index);
};




#endif

	
