/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>

#include "FeatMatrix.h"
#include "MSignal.h"
#include "fmatrix.h"
#include "SoundFileIO.h"
#include "defs.h"
#include "Util.h"
#include "Gain.h"
#include "Hamming.h"
#include "MagFFT.h"
#include "FeatExtractor.h"
#include "LabelList.h"
#include "Collection.h"


void 
blabel(string ffile, vector<string> labels, int label)
{
  FeatMatrix fmatrix;
  ifstream ffile_s(ffile.c_str());
  cerr << "Labeling feature file " << ffile << " with label " << label << "(" << labels[label] << ")" << endl;
  ffile_s >> fmatrix;
  // fmatrix.label(labels, label);
  ofstream out(ffile.c_str());
  out << fmatrix;
}

 

int
main(int argc, char **argv)
{
  if (argc < 2)
    {
      cerr << "Usage : " << argv[0] <<" collections \n";
      exit(1);
    }
  int numCollections = argc - 1;
  
  int c;
  vector<string> labels;
  labels.reserve(100);
  
  
  for (c=0; c < numCollections; c++)
    {
      string collectionstr = MARSYAS_MFDIR;
      collectionstr += "/collections/";
      collectionstr += argv[c+1];
      
      /* string labelliststr = MARSYAS_MFDIR;
	 labelliststr += "/labellists/";
	 labelliststr += argv[2];
      */
      ifstream from(collectionstr.c_str());
      Collection l;
      from >> l;
      cout << "Collection Name = " << l.name() << endl;
      labels.push_back(l.name());
    }

  for (c=0; c < numCollections; c++)
    {
      string collectionstr = MARSYAS_MFDIR;
      collectionstr += "/collections/";
      collectionstr += argv[c+1];
      
      /* string labelliststr = MARSYAS_MFDIR;
	 labelliststr += "/labellists/";
	 labelliststr += argv[2];
      */
      ifstream from(collectionstr.c_str());
      Collection l;
      from >> l;
      for (unsigned int i=0; i<l.size(); i++)
	{
	  blabel(l.entry(i), labels, c);
	}  
    }

  return 0;
}
