/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#include "Collection.h" 
#include "defs.h"
#include "MSignal.h" 
#include "Util.h"
#include "AuFileIO.h"

#ifndef WIN32
#include "Audio.h"
#else
#include "system/AudioDummy.h"
#endif

int 
main(int argc, char **argv) 
{
  unsigned int i,j,k;
  if (argc == 1) 
    {
      cerr << "Usage : " << argv[0] << " collection dest offset(sec) duration(sec)\n";
      exit(1);
    }
  
  string collectionstr = MARSYAS_MFDIR;
  collectionstr += "/collections/";
  collectionstr += argv[1];
  Collection l;
  l.read(collectionstr);
  string deststr = argv[2];
  int offset = atoi(argv[3]);
  int duration = atoi(argv[4]);
  

  
  MSignal *src;
  Util util;
  // Audio audio(22050, 1, MRS_AUDIO_PLAY, 512);
  AuFileIO *dest;
  dest = new AuFileIO(deststr, MRS_SF_WRITE);
  dest->init();
      
  fvec window(512);
  
  k=0;
  for (i=0; i < l.size(); i++) 
    {
      cout << l.entry(i) << endl;
      src = util.sfopen(l.entry(i), MRS_SF_READ);
      if (src == NULL) 
	{
	  exit(1);
	}
      src->initWindow(512, 512, 0,0);
      for (j= (unsigned int)offset * 40; j < (unsigned int)(offset + duration) * 40; j++)
	{
	  src->get(window, j);
	  dest->put(window, k);
	  //audio.put(window,k);
	  k++;
	}
      delete src;
    }
  delete dest;
  cout << "I am out of the loop what is going on " << endl;
  return 0;
  
}
