#include <stdlib.h>			// standard libs
#include <stdio.h>			// standard I/O (for NULL)
#include <math.h>			// math includes
#include <algorithm>
#include "fvec.h"			// special values
#include "fmatrix.h"	    // I/O streams
#include "FeatMatrix.h"

  
#define PRINCIPAL_ERROR 0.001
#define MIN_RECALC      20
#define EMPTY           -1


class node
{
public:
	int		cc;			//count of children
	node 	**children;	//array of children
	int		*index;
	fvec	principal;	
	fvec	min;
	fvec 	max;
	node(
		int 	num,
    	int 	*i,
    	node	**child,
    	fvec	princ,
    	fvec	mn,
    	fvec	mx);
    ~node();
    friend class knnTree;
};


   
class knnTree
{
private:
    int				dim;		// dimension of space
    int				num;		// number of points in tree
    int				cc;			// child count
    int             knum;       // number of nns to returnr
    int				*index;		// index to points
    int				*nns;		// array of nns 
    float			*dist;		// distance array for nns
    FeatMatrix		*values;	// points
    node			*root;		// root of tree

    void knnSearch(
        node    *child,			
		fvec	q,				// query point
		fvec    b,
		int		lb);
    
    void partialDist(
        node    *terminal,
        fvec    vec2); 
    
    void sort(float *a, int *b, int l, int r);
    
	node *buildTree(
		FeatMatrix	*pa,	
		int			n,			// number of points
		int			dd,			// dimension
		int			cn,  		// child nodes
		int			*index);

    void writeNode(node *n, ofstream &tos);
    
    node* readNode(ifstream &tis);	
		
public:  

    knnTree(
		FeatMatrix	*pa,	
		int			n,			// number of points
		int			dd,			// dimension
		int			cn);	    // child nodes

    ~knnTree();					// tree destructor

    void makeTree();

    void findKnn(
        fvec    q,              // query point
        int		k,
 		int		*mins,			// nns to return
 		float	*dists);		// distances

    void write(string name);
    void read(string name);
    void dump(node *n);
};

