//#include <iostream.h>
//#include <math.h>
#include "pitchfind.h"

//A = 27.5 Hz

int
pitchfind(float x)
{  
  float n=0.0;
//  char *notes[12]={"A","A#","B","C","C#","D","D#","E","F","F#","G","G#"};
  if (x<55)
   { //cout << "very low" << endl; 
     return 13;
   }
  while(x >= 55) {x=x/2.0;}   //55=2*27.5
  float diff=x/27.5;

  n=log10(diff); n=12*n/log10(2.0);
//  cout << "n=" << n << " " << endl;
  if ((int)(n+0.49) != (int)n)  // hack to find note closest to given freq 
    { n=(int)(n+0.49); }

//  diff=pow(diff, 12);  //now diff=2^n  
/*
  while(diff>=1)
    { diff=diff/2; 
      n++;
    }
*/
  if(n==12) n=0;
//  cout << notes[(int)n]<< " ";
  return (int)n;
}




int
pitchfind_unfolded(float x)
{  
  float n=0.0;
  int octave=0;
  char *notes[12]={"A","A#","B","C","C#","D","D#","E","F","F#","G","G#"};
  if (x<55)
   { // cout << "very low" << endl; 
     return 0;
   }
  while(x >= 55) { x=x/2.0; octave++;  }   //55=2*27.5
  float diff=x/27.5;

  n=log10(diff); n=12*n/log10(2.0);

  if ((int)(n+0.49) != (int)n)  // hack to find note closest to given freq 
    { n=(int)(n+0.49); }

  if(n==12) n=0;
//  cout << notes[(int)n]<< octave <<" ";

  n+=octave*12;  //n has lower limit of 0 (lowest A)  
  return (int)n;
}





int
keyfind(fvec& myvec)
{ 
//  char *keytype[3]={"Major", "Minor", "(not clearly maj or min)"};
//     char *notes[12]={"A","A#","B","C","C#","D","D#","E","F","F#","G","G#"};
     float max[4]; max[0]=max[1]=max[2]=max[3]=0;
     int jmax[4]; jmax[0]=jmax[1]=jmax[2]=jmax[3]=0;
     int j, tonic, typenum;
     myvec.abs();
     myvec(13)=0;  //remove the significance of "very low"

     for (j=0; j<12; j++)
       { //max[3] is biggest, max[0] is 3rd biggest
         if(myvec(j) > max[3])
          {  max[0]=max[1]; jmax[0]=jmax[1];
             max[1]=max[2]; jmax[1]=jmax[2];
             max[2]=max[3]; jmax[2]=jmax[3];
             max[3]=myvec(j); jmax[3]=j;
          }    
         if(myvec(j) > max[2] && myvec(j) < max[3])
           { max[0]=max[1]; jmax[0]=jmax[1];
	     max[1]=max[2]; jmax[1]=jmax[2];
             max[2]=myvec(j); jmax[2]=j;
           }
         if(myvec(j) > max[1] && myvec(j) < max[2])
           { max[0]=max[1]; jmax[0]=jmax[1];
	     max[1]=myvec(j); jmax[1]=j;
           }           
         if(myvec(j) > max[0] && myvec(j) < max[1])
           { max[0]=myvec(j); jmax[0]=j;
           }
       }

     tonic=jmax[3];
     if ((tonic+4)%12 == jmax[0] || (tonic+4)%12 == jmax[1] || (tonic+4)%12 ==jmax[2])
       { typenum = 0; } //major
     else if ((tonic+3)%12 == jmax[0] || (tonic+3)%12 == jmax[1] || (tonic+3)%12 ==jmax[2])
       { typenum = 1; } //minor 
     else typenum = 2;  //unclear

//     cout << "key is likely " << notes[tonic]<< " "<< keytype[typenum] << endl;

     return tonic;
}
