/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>

#include "FeatMatrix.h"
#include "MSignal.h"
#include "fmatrix.h"
#include "defs.h"
#include "Collection.h"


/* to create the pcaWeights matrix do the following steps:
 * run covariance (some list of files you are interested) res (covariance matrix) 
 * then using some external tool (like octave) calculate 
 * the eigenvectors matrix 
 * in octave: load res, [V, D] = eig(m), PR = V' save eigen
 * Edit eigen deleting everything except PR and making a MARSYAS fmatrix 
 * This matrix is the one using for standarizeing the feature with pca. 
 */ 

void
standarize(string srcStr, string standarizeStr)
{
  return;
  /* FeatMatrix src;
  src.read(srcStr);
  
  cout << "Standarizeion matrix for multiplying " << srcStr << " = " << projectStr << endl;
 
  src *= projectMatrix;
  unsigned int c;
  vector<string> names;
  for (c =0; c < src.cols(); c++)
    {
      names.push_back("Projected");
    }
  src.changefeatNames(names);
  string resStr = srcStr + ".prj";
  cout << "Writing " << resStr << endl;
  ofstream to(resStr.c_str());
  to << src;
  return resStr;
  */
}

 

int
main(int argc, char **argv)
{
  if (argc == 1)
    {
      cerr << "Usage :" << argv[0] <<" extractor collections\n";
      exit(1);
    }
  unsigned int numClasses = argc -2;
  unsigned int size;
  unsigned int cl;
  unsigned int m;
  string extractorStr = argv[1];
  cout << "Extractor = " << extractorStr << endl;  
  
  for (cl = 0; cl < numClasses; cl++)
    {
      cout << "Class " << cl << " collection is :" << argv[cl+2] << endl;
    }
  
  vector <FeatMatrix *> allMatrices;
  allMatrices.reserve(1000);
  ivec collectionSizes;
  collectionSizes.create(numClasses);
  
  unsigned int count = 0;
  for (cl = 0; cl < numClasses; cl++)
    {
      string collectionstr = MARSYAS_MFDIR;
      string cname = argv[cl+2];
      cname = cname.substr(0, cname.size()-3); // remove .mf
      collectionstr += "/featurefiles/";
      collectionstr += cname;
      collectionstr += extractorStr;
      collectionstr += ".mf";
      
      ifstream from(collectionstr.c_str());
      
      allMatrices.push_back(new FeatMatrix());
      while (from >> *(allMatrices[count]))
	{
	  allMatrices.push_back(new FeatMatrix());
	  cout << "reading " << allMatrices[count]->name() << endl;
	  count++;
	  collectionSizes(cl)++;
	}
      allMatrices.pop_back();
    }
  FeatMatrix trainMatrix(allMatrices);
  fvec meanRow = trainMatrix.meanRow();
  fvec stdRow = trainMatrix.stdRow();
  

  unsigned int i;
  count =0;
  
  
  for (cl = 0; cl < numClasses; cl++)
    {
      string destStr = MARSYAS_MFDIR;
      string cname = argv[cl+2];
      destStr += "/featurefiles/";
      cname = cname.substr(0, cname.size()-3); // remove .mf
      destStr += "std";
      destStr += cname;
      destStr += ".mf";
      ofstream to(destStr.c_str());

      for (i=0; i < collectionSizes(cl); i++)
	{
	  allMatrices[count]->standarize(meanRow, stdRow);
	  to << *(allMatrices[count]) << endl;
	  count++;
	}
      cout << "Wrote " << destStr << endl;
    }
  
  return 0;
}
